;-------------------------------------------------------------------------------
; global constants that should be program independant
;-------------------------------------------------------------------------------
; 68k memory map
CTRL_1_DATA=$00A10003
CTRL_2_DATA=$00A10005
CTRL_X_DATA=$00A10007
CTRL_1_CONTROL=$00A10009
CTRL_2_CONTROL=$00A1000B
CTRL_X_CONTROL=$00A1000D
REG_HWVERSION=$00A10001
REG_TMS=$00A14000
PSG_INPUT=$00C00011
RAM_START=$00FF0000
VDP_DATA=$00C00000
VDP_CONTROL=$00C00004
VDP_COUNTER=$00C00008
Z80_ADDRESS_SPACE=$00A10000
Z80_BUS=$00A11100
Z80_RESET=$00A11200

; VDP access modes
VDP_CRAM_READ=$20000000
VDP_CRAM_WRITE=$C0000000
VDP_VRAM_READ=$00000000
VDP_VRAM_WRITE=$40000000
VDP_VSRAM_READ=$10000000
VDP_VSRAM_WRITE=$14000000

; VDP status
VDP_STATUS_FIFO_EMPTY=$0200
VDP_STATUS_FIFO_FULL=$0100
VDP_STATUS_VINT_PENDING=$0080
VDP_STATUS_SPRITE_OVERFLOW=$0040
VDP_STATUS_SPRITE_COLLISION=$0020
VDP_STATUS_ODD_FRAME=$0010
VDP_STATUS_VBLANK=$0008
VDP_STATUS_HBLANK=$0004
VDP_STATUS_DMA=$0002
VDP_STATUS_PAL=$0001

; buttons
BUTTON_UP=%00000001
BUTTON_DOWN=%00000010
BUTTON_LEFT=%00000100
BUTTON_RIGHT=%00001000
BUTTON_B=%00010000
BUTTON_C=%00100000
BUTTON_A=%01000000
BUTTON_START=%10000000
BUTTON_Z=%00000001
BUTTON_Y=%00000010
BUTTON_X=%00000100
BUTTON_MODE=%00001000

; these are based on registers 2,3,4,5,13 in data_VDPInit.X68
VDP_VRAM_WRITE_A=$40000003	; register 2
VDP_VRAM_WRITE_HSCROLL=$7C000002	; register 13
VDP_VRAM_WRITE_SPRITE=$78000002	; register 5
VDP_VRAM_WRITE_B=$60000003	; register 4
VDP_VRAM_WRITE_WINDOW=$60000002	; register 3
VDP_VRAM_WRITE_VSCROLL=$40000010	; vscroll write

; other constants
WORD_SIZE=$2
LWORD_SIZE=$4
LWORDS_PER_TILE=$8	; how many lwords of data in each tile
VDP_PLANE_PIXELS_X=$0200	; width of VDP plane
VDP_PLANE_PIXELS_Y=$0100	; height of VDP plane
DISPLAY_PIXELS_X=$0140	; width of physical display
DISPLAY_PIXELS_Y=$00E0	; height of physical display

