;*******************************************************************************
; This borrows heavily from RetailClerk89
; This makes the code a little larger than it needs to be maybe
; There is very little optimization in the code
;
; Build this using: 
;	vasmm68k_mot -o 6ButtonControllerDemo.bin -Fbin -spaces main.X68
;
; Visit https://HuguesJohnson.com/ for random programming articles
;*******************************************************************************

;*******************************************************************************
; constants
;*******************************************************************************

;-------------------------------------------------------------------------------
; constants
;-------------------------------------------------------------------------------
STATE_FLAG_VBLANK=$0	; flag used to track vblank status
SRAM_START=$200001	; SRAM start address
SRAM_END=$20FFFF	; SRAM end address
ROW_HEIGHT=$800000	; height of a tile row
FONT_VDP=$1200	; address to store fonts in vdp
ETX=$03	; end of text
DIALOG_BASE_TILE=$8090	; base tile for text
	include 'constants.X68'

;-------------------------------------------------------------------------------
; memory map
;-------------------------------------------------------------------------------
	include 'memorymap.X68'

;*******************************************************************************
; vectors
;*******************************************************************************
	include 'init_Vectors.X68'

;*******************************************************************************
; ROM header
;*******************************************************************************
	include 'init_Header.X68'

;*******************************************************************************
; entry point & initialization
;*******************************************************************************
	include 'init_MDInit.X68'

;*******************************************************************************
; main game program
;*******************************************************************************

Main:

	move.w	#$2700,sr		; disable interrupts

	;---------------------------------------------------------------------------
	; load tiles
	;---------------------------------------------------------------------------
	clr.l	d1	; use d1 to track VDP write location
	bsr.w	BuildVRAMWriteAddress
	move.l	#TilesStart,d3	; start address of tileset
	move.l	#TilesEnd,d0	; end address of tileset
	sub.l	d3,d0	; subtract the start address to get length
	divu.w	#$0004,d0	; divide by 4 to setup call to LoadTiles
	movea.l	#TilesStart,a0	; set address of first tile to load
	bsr.w	LoadTiles	; branch to LoadTiles subroutine

	; font tiles
	move.w	#FONT_VDP,d1	; setup call to BuildVRAMWriteAddress
	bsr.w	BuildVRAMWriteAddress	; build the VRAM write address
	move.l	#FontTilesStart,d2	; start address of tileset
	move.l	#FontTilesEnd,d0	; end address of tileset
	sub.l	d2,d0	; subtract the start address to get length
	divu.w	#$0004,d0	; divide by 4 to setup call to LoadTiles
	movea.l	d2,a0	; set address of first tile to load
	bsr.w	LoadTiles	; branch to LoadTiles subroutine

	;---------------------------------------------------------------------------
	; load palettes
	;---------------------------------------------------------------------------
	lea	(Palette0),a0	; point to first palette
	moveq	#$0004,d0	; number of palettes to load
	move.l	#VDP_CRAM_WRITE,d1	; initial write address
	bsr.w	LoadPalettes	; branch to LoadPalettes subroutine

	;---------------------------------------------------------------------------
	; draw the controller
	;---------------------------------------------------------------------------
	movea.l	#PatternController,a0	; start address of pattern
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0000000000000001,d0	; base pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$000C0000+$00800000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine

	;---------------------------------------------------------------------------
	; draw the captions
	;---------------------------------------------------------------------------
	lea	LabelControllerID,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$00180000+$05800000,a1	; drawing location
	bsr.w	DrawText
	lea	Label6ButtonController,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000C0000+$06000000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelButtonsHeld,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$001A0000+$06800000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelButtonsPressed,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$00140000+$07000000,a1	; drawing location
	bsr.w	DrawText
	lea	Label6ButtonsHeld,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$00160000+$07800000,a1	; drawing location
	bsr.w	DrawText
	lea	Label6ButtonsPressed,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$00100000+$08000000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug,a0	; start address of text
	move.w	#DIALOG_BASE_TILE+%0100000000000000,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$00000000+$09000000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug1,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$09800000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug2,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$0A000000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug3,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$0A800000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug4,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$0B000000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug5,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$0B800000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug6,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$0C000000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug7,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$0C800000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug8,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$0D000000,a1	; drawing location
	bsr.w	DrawText
	lea	LabelDebug9,a0	; start address of text
	move.w	#DIALOG_BASE_TILE,d0	; base pattern
	movea.l	#VDP_VRAM_WRITE_B+$000A0000+$0D800000,a1	; drawing location
	bsr.w	DrawText

	move.w	#$2000,sr		; re-enable interrupts

MainLoop:
	bsr.w	WaitVBlank ; wait for vblank to complete
	;---------------------------------------------------------------------------
	; test the state of each button and draw it accordingly
	; this is not optimized at all since this is a demo	
	;---------------------------------------------------------------------------
	;------------------------
	; up
	;------------------------
	move.b	(MEM_CONTROL_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_UP,d6	; test if the up button was pressed
	bne.s	ButtonUpPressed
	move.b	(MEM_CONTROL_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_UP,d6	; test if the up button was pressed
	bne.s	ButtonUpHeld
ButtonUpDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000010000,d0	; base pattern
	bra.s	ButtonUpDraw
ButtonUpPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000010000,d0	; base pattern
	bra.s	ButtonUpDraw
ButtonUpHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000010000,d0	; base pattern
ButtonUpDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00140000+$01800000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; down
	;------------------------
	move.b	(MEM_CONTROL_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_DOWN,d6	; test if the down button was pressed
	bne.s	ButtonDownPressed
	move.b	(MEM_CONTROL_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_DOWN,d6	; test if the down button was pressed
	bne.s	ButtonDownHeld
ButtonDownDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000010100,d0	; base pattern
	bra.s	ButtonDownDraw
ButtonDownPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000010100,d0	; base pattern
	bra.s	ButtonDownDraw
ButtonDownHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000010100,d0	; base pattern
ButtonDownDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00140000+$03800000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; left
	;------------------------
	move.b	(MEM_CONTROL_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_LEFT,d6	; test if the left button was pressed
	bne.s	ButtonLeftPressed
	move.b	(MEM_CONTROL_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_LEFT,d6	; test if the left button was pressed
	bne.s	ButtonLeftHeld
ButtonLeftDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000011000,d0	; base pattern
	bra.s	ButtonLeftDraw
ButtonLeftPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000011000,d0	; base pattern
	bra.s	ButtonLeftDraw
ButtonLeftHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000011000,d0	; base pattern
ButtonLeftDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00100000+$02800000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; right
	;------------------------
	move.b	(MEM_CONTROL_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_RIGHT,d6	; test if the right button was pressed
	bne.s	ButtonRightPressed
	move.b	(MEM_CONTROL_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_RIGHT,d6	; test if the right button was pressed
	bne.s	ButtonRightHeld
ButtonRightDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000011100,d0	; base pattern
	bra.s	ButtonRightDraw
ButtonRightPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000011100,d0	; base pattern
	bra.s	ButtonRightDraw
ButtonRightHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000011100,d0	; base pattern
ButtonRightDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00180000+$02800000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; start
	;------------------------
	move.b	(MEM_CONTROL_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_START,d6	; test if the start button was pressed
	bne.s	ButtonStartPressed
	move.b	(MEM_CONTROL_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_START,d6	; test if the start button was pressed
	bne.s	ButtonStartHeld
ButtonStartDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000111000,d0	; base pattern
	bra.s	ButtonStartDraw
ButtonStartPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000111000,d0	; base pattern
	bra.s	ButtonStartDraw
ButtonStartHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000111000,d0	; base pattern
ButtonStartDraw:
	movea.l	#PatternButtonRect,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00220000+$02000000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; a
	;------------------------
	move.b	(MEM_CONTROL_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_A,d6	; test if the a button was pressed
	bne.s	ButtonAPressed
	move.b	(MEM_CONTROL_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_A,d6	; test if the a button was pressed
	bne.s	ButtonAHeld
ButtonADefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000100000,d0	; base pattern
	bra.s	ButtonADraw
ButtonAPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000100000,d0	; base pattern
	bra.s	ButtonADraw
ButtonAHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000100000,d0	; base pattern
ButtonADraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00300000+$03800000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; b
	;------------------------
	move.b	(MEM_CONTROL_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_B,d6	; test if the b button was pressed
	bne.s	ButtonBPressed
	move.b	(MEM_CONTROL_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_B,d6	; test if the b button was pressed
	bne.s	ButtonBHeld
ButtonBDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000100100,d0	; base pattern
	bra.s	ButtonBDraw
ButtonBPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000100100,d0	; base pattern
	bra.s	ButtonBDraw
ButtonBHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000100100,d0	; base pattern
ButtonBDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00360000+$03000000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; c
	;------------------------
	move.b	(MEM_CONTROL_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_C,d6	; test if the c button was pressed
	bne.s	ButtonCPressed
	move.b	(MEM_CONTROL_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_C,d6	; test if the c button was pressed
	bne.s	ButtonCHeld
ButtonCDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000101000,d0	; base pattern
	bra.s	ButtonCDraw
ButtonCPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000101000,d0	; base pattern
	bra.s	ButtonCDraw
ButtonCHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000101000,d0	; base pattern
ButtonCDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$003C0000+$02800000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; x
	;------------------------
	move.b	(MEM_CONTROL_6_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_X,d6	; test if the x button was pressed
	bne.s	ButtonXPressed
	move.b	(MEM_CONTROL_6_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_X,d6	; test if the x button was pressed
	bne.s	ButtonXHeld
ButtonXDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000101100,d0	; base pattern
	bra.s	ButtonXDraw
ButtonXPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000101100,d0	; base pattern
	bra.s	ButtonXDraw
ButtonXHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000101100,d0	; base pattern
ButtonXDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00300000+$02000000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; y
	;------------------------
	move.b	(MEM_CONTROL_6_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_Y,d6	; test if the y button was pressed
	bne.s	ButtonYPressed
	move.b	(MEM_CONTROL_6_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_Y,d6	; test if the y button was pressed
	bne.s	ButtonYHeld
ButtonYDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000110000,d0	; base pattern
	bra.s	ButtonYDraw
ButtonYPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000110000,d0	; base pattern
	bra.s	ButtonYDraw
ButtonYHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000110000,d0	; base pattern
ButtonYDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00360000+$01800000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; z
	;------------------------
	move.b	(MEM_CONTROL_6_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_Z,d6	; test if the z button was pressed
	bne.s	ButtonZPressed
	move.b	(MEM_CONTROL_6_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_Z,d6	; test if the z button was pressed
	bne.s	ButtonZHeld
ButtonZDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000110100,d0	; base pattern
	bra.s	ButtonZDraw
ButtonZPressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000110100,d0	; base pattern
	bra.s	ButtonZDraw
ButtonZHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000110100,d0	; base pattern
ButtonZDraw:
	movea.l	#PatternButtonSquare,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$003C0000+$01000000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine
	;------------------------
	; mode
	;------------------------
	move.b	(MEM_CONTROL_6_PRESSED),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_MODE,d6	; test if the mode button was pressed
	bne.s	ButtonModePressed
	move.b	(MEM_CONTROL_6_HELD),d6	; copy pressed buttons to d6
	andi.b	#BUTTON_MODE,d6	; test if the mode button was pressed
	bne.s	ButtonModeHeld
ButtonModeDefault:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0010000000111100,d0	; base pattern
	bra.s	ButtonModeDraw
ButtonModePressed:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0110000000111100,d0	; base pattern
	bra.s	ButtonModeDraw
ButtonModeHeld:
	; 		#%pccvhnnnnnnnnnnn
	move.w	#%0100000000111100,d0	; base pattern
ButtonModeDraw:
	movea.l	#PatternButtonRect,a0	; start address of pattern
	move.w	#$0000,d1	; repeat
	movea.l	#VDP_VRAM_WRITE_B+$00220000+$03000000,a1	; drawing location
	bsr.w	DrawTileset		; branch to DrawTileset subroutine

	;----------------------------
	; regular variables
	;----------------------------
	moveq	#0,d4	; use d4 for loop control
	move.l	#VDP_VRAM_WRITE_B+$00340000+$05800000,d2	; intial draw location
	lea	(MEM_CONTROL_1_ID),a2	; first value
WriteMemLoop:
	movea.l	d2,a1	; drawing location
	move.b	(a2),d6	; value to write
	bsr.w	DrawBin	; branch to DrawBin
	; increment stuff
	adda.l	#$00000002,a2	; increment address a2 is pointing to
	add.l	#$00800000,d2	; increment vdp write address
	addq	#1,d4	; increment loop control
	cmpi.w	#$5,d4	; test if at the end
	ble.s	WriteMemLoop	; loop

	;----------------------------
	; debug values
	;----------------------------
	moveq	#0,d4	; use d4 for loop control
	move.l	#VDP_VRAM_WRITE_B+$00220000+$09800000,d2	; left column
	move.l	#VDP_VRAM_WRITE_B+$00340000+$09800000,d3	; right column
	lea	(MEM_DEBUG_CYCLE1_INIT),a2	; first init debug value
	lea	(MEM_DEBUG_CYCLE1_VBLANK),a3	; first vblank debug value
WriteDebugLoop:
	movea.l	d2,a1	; drawing location
	move.b	(a2),d6	; value to write
	bsr.w	DrawBin	; branch to DrawBin
	movea.l	d3,a1	; drawing location
	move.b	(a3),d6	; value to write
	bsr.w	DrawBin	; branch to DrawBin
	; increment stuff
	adda.l	#$00000002,a2	; increment address a2 is pointing to
	adda.l	#$00000002,a3	; increment address a3 is pointing to
	add.l	#$00800000,d2	; increment vdp write address (left column)
	add.l	#$00800000,d3	; increment vdp write address (right column)
	addq	#1,d4	; increment loop control
	cmpi.w	#$8,d4	; test if at the end
	ble.s	WriteDebugLoop	; loop

	bra.w	MainLoop

;-------------------------------------------------------------------------------
; WaitVBlank
;-------------------------------------------------------------------------------
WaitVBlank:
	btst	#STATE_FLAG_VBLANK,(MEM_GAME_STATE)	; test vblank flag
	beq.s	WaitVBlank	; loop until flag changes
	bclr	#STATE_FLAG_VBLANK,(MEM_GAME_STATE)	; clear vblank flag
	rts	; exit

;*******************************************************************************
; traps
;*******************************************************************************

ExtInt:
	rte

HBlank:
	rte

VBlank:
	bset	#STATE_FLAG_VBLANK,(MEM_GAME_STATE)	; set vblank flag

VBlankReadJoypads:
	bsr.w	ReadJoypads					; read controllers

VBlankExit:
	rte

TrapException:
	rte

;*******************************************************************************
; subroutines
;*******************************************************************************
	include 'sub_ReadJoypads.X68'
	include 'sub_ClearVRAM.X68'
	include 'sub_LoadPalettes.X68'
	include 'sub_LoadTiles.X68'
	include 'sub_DrawTileset.X68'
	include 'sub_BuildVRAMWriteAddress.X68'

DrawText:
LoadSceneDrawTextNextCharacter:
	clr	d6	; clear out d6
	move.b	(a0),d6	; copy current character to d6
	cmpi.b	#ETX,d6	; is this the end of the text?
	beq.s	LoadSceneDrawTextLoopEnd	; end of this string, move to next one
	sub.w	#$20,d6	; subtract 32 to get the character index
	; draw the character
	add.w	d0,d6	; add the base tile
	move.l	a1,(VDP_CONTROL)	; set VDP address
	move.w  d6,(VDP_DATA)	; copy the character to VPD
	; increment for next character
	adda.l	#$00000001,a0	; move to next character in the string
	add.l	#$00020000,a1	; move to the next column
	bra.s	LoadSceneDrawTextNextCharacter	; repeat until ETX is reached
LoadSceneDrawTextLoopEnd:
	rts

DrawBin:
	moveq	#7,d7
DrawBinLoop:
	btst	d7,d6
	beq.s	.Zero
	move.w	#DIALOG_BASE_TILE+%0110000000010001,d5	; base pattern	
	bra.s	.Draw
.Zero
	move.w	#DIALOG_BASE_TILE+%0110000000010000,d5	; base pattern	
.Draw
	move.l	a1,(VDP_CONTROL)	; set VDP address
	move.w  d5,(VDP_DATA)	; copy the character to VPD
	; increment for next character
	add.l	#$00020000,a1	; move to the next column
	dbpl	d7,DrawBinLoop
	rts

;*******************************************************************************
; initialization data
;*******************************************************************************
	include 'data_Z80Init.X68'

	include 'data_VDPInit.X68'

;*******************************************************************************
; palettes
;*******************************************************************************
	include 'palettes.X68'

;*******************************************************************************
; patterns
;*******************************************************************************
	include 'patterns.X68'

;*******************************************************************************
; tiles
;*******************************************************************************
	include 'tiles.X68'

FontTilesStart:
	include 'dwf.X68'
FontTilesEnd:

;*******************************************************************************
; strings
;*******************************************************************************
	align 2

LabelControllerID:
	dc.b	"Controller ID=",ETX

Label6ButtonController:
	dc.b	"6 button controller=",ETX

LabelButtonsHeld:
	dc.b	"Buttons held=",ETX

LabelButtonsPressed:
	dc.b	"Buttons pressed=",ETX

Label6ButtonsHeld:
	dc.b	"6 buttons held=",ETX

Label6ButtonsPressed:
	dc.b	"6 buttons pressed=",ETX

LabelDebug:
	;		"12345678901234567890123456789012345678"
	dc.b	"     Cycle Debug Init     VBlank read ",ETX

LabelDebug1:
	dc.b	"1 (TH high)",ETX

LabelDebug2:
	dc.b	"2 (TH low)",ETX

LabelDebug3:
	dc.b	"3 (TH high)",ETX

LabelDebug4:
	dc.b	"4 (TH low)",ETX

LabelDebug5:
	dc.b	"5 (TH high)",ETX

LabelDebug6:
	dc.b	"6 (TH low)",ETX

LabelDebug7:
	dc.b	"7 (TH high)",ETX

LabelDebug8:
	dc.b	"8 (TH low)",ETX

LabelDebug9:
	dc.b	"9 (TH high)",ETX

;*******************************************************************************
; end of rom
;*******************************************************************************

RomEnd:
	dc.b	%11111111
    end 0
