;-------------------------------------------------------------------------------
; These sub-routines are not entirely my original code.
; This are based off various samples available online (see credits file).
; I made some modifications but probably not enough to qualify as original work.
;-------------------------------------------------------------------------------
ReadJoypads:
	move.w	#$2700,sr		; disable interrupts
	lea	CTRL_1_DATA,a0		; load address to read controller 1 data
	bsr.s	ReadJoypad		; read first joypad
	; code to read second joypad, not used for this demo
	; addq.w	#2,a0		; switch to second joypad data
	; bsr.s	ReadJoypad		; read second joypad
	move.w	#$2000,sr		; re-enable interrupts
	rts
	
ReadJoypad:
	;---------------------------------
	; set counter to 1 + TH high
	;---------------------------------
	move.b	#$40,(a0)	; set TH high
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),d0		; get joypad data - C/B/Dpad
	move.b	d0,(MEM_DEBUG_CYCLE1_VBLANK)
	andi.b	#%00111111,d0	; C/B/Dpad in low 6 bits
	;---------------------------------
	; set counter to 2 + TH low
	;---------------------------------
	move.b	#$00,(a0)	; set TH low
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),d1		; get joypad data - Start/A
	move.b	d1,(MEM_DEBUG_CYCLE2_VBLANK)
	lsl.b	#2,d1		; shift them so they are at the 2 highest bits
	andi.b	#%11000000,d1	; Start/A in high 2 bits - clear others
	or.b	d1,d0		; merge values from both registers
	not.b	d0			; flip bits so 0 means not pressed, and 1 means pressed
	move.b	d0,d1		; copy current buttons to d1
	move.b	(MEM_CONTROL_HELD),d2		; copy the last previously read buttons
	eor.b	d2,d0		; flip buttons being pressed now
	move.b	d1,(MEM_CONTROL_HELD)	; store held buttons
	and.b	d1,d0		; AND with current buttons
	move.b	d0,(MEM_CONTROL_PRESSED)	; store pressed buttons
	; if this is a 3 button controller skip the remaining steps 
	move.b	(MEM_CONTROL_1_6BUTTON),d0	; save the value
	tst.b	d0	; is this zero?
	beq.w	ExitReadJoypad	; zero means 3 button controller
	;---------------------------------
	; set counter to 3 + TH high
	;---------------------------------
	move.b	#$40,(a0)	; set TH high
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),(MEM_DEBUG_CYCLE3_VBLANK)
	;---------------------------------
	; set counter to 4 + TH low
	;---------------------------------	
	move.b	#$00,(a0)	; set TH low
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),(MEM_DEBUG_CYCLE4_VBLANK)
	;---------------------------------
	; set counter to 5 + TH high
	;---------------------------------	
	move.b	#$40,(a0)	; set TH high
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),(MEM_DEBUG_CYCLE5_VBLANK)
	;---------------------------------
	; set counter to 6 + TH low
	;---------------------------------	
	move.b	#$00,(a0)	; set TH low
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),(MEM_DEBUG_CYCLE6_VBLANK)
	;---------------------------------
	; set counter to 7 + TH high
	;---------------------------------	
	move.b	#$40,(a0)	; set TH high
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),d0		; get joypad data - x/y/z/mode
	move.b	d0,(MEM_DEBUG_CYCLE7_VBLANK)
	not.b	d0			; flip bits so 0 means not pressed, and 1 means pressed
	and.b	#%00001111,d0	; x/y/z/mode are in lowest 4 bits
	move.b	d0,d1		; copy current buttons to d1
	move.b	(MEM_CONTROL_6_HELD),d2		; copy the last previously read buttons
	eor.b	d2,d0		; flip buttons being pressed now
	move.b	d1,(MEM_CONTROL_6_HELD)	; store held buttons
	and.b	d1,d0		; AND with current buttons
	move.b	d0,(MEM_CONTROL_6_PRESSED)	; store pressed buttons
	;---------------------------------
	; set counter to 8 + TH low
	;---------------------------------	
	move.b	#$00,(a0)	; set TH low
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),(MEM_DEBUG_CYCLE8_VBLANK)
	;---------------------------------
	; set counter to 9 + TH high
	;---------------------------------
	move.b	#$40,(a0)	; set TH high
	nop					; bus synchronization
	nop					; bus synchronization
	move.b	(a0),(MEM_DEBUG_CYCLE9_VBLANK)
	;---------------------------------
	; done reading controller
	;---------------------------------
ExitReadJoypad:
	rts
